Summary: The GNOME Display Manager
Name: gdm
Release: %mkrel 4
Version: 2.20.11
License: GPLv2+
Group: Graphical desktop/GNOME
URL: http://www.gnome.org/projects/gdm/
Source0: ftp://ftp.gnome.org/pub/GNOME/sources/gdm/%{name}-%{version}.tar.xz
Source2: gdm_48.png
Source3: gdm_32.png
Source4: gdm_16.png
Source5: gdm-consolekit.conf
Source6: 90-grant-audio-devices-to-gdm.fdi
Source7: gdmsetup.desktop
Source8: defaults.conf
Source9: factory-defaults.conf
Patch0: gdm-2.20.10-defaultconf.patch
Patch1: gdm-2.19.1-xvt.patch
Patch4: gdm-pam.patch
Patch5: gdm-2.19.0-cleanup-xses.patch
Patch6: gdm-2.19.1-tmpdir.patch
Patch7: gdm-2.20.2-usermode.patch
Patch8: gdm-2.19.8-gdmlang.patch
Patch10: gdm-2.20.1-zhlocale.patch
Patch12: gdm-2.20.3-face.patch
Patch14: gdm-2.20.9-format-strings.patch
Patch15: gdm-2.20.10-rootpixmap.patch
Patch16: gdm-2.20.0-wait-for-restart.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root

Provides: dm
Obsoletes: xfce-gdm
Conflicts: legacy-gdm
Requires(pre):     rpm-helper
Requires(postun):  rpm-helper
Requires(post):	   scrollkeeper >= 0.3
Requires(postun):  scrollkeeper >= 0.3
Requires(post): desktop-common-data
Requires: pam >= 0.99.8.1
Requires: setup >= 2.1.9-33mdk
Requires: sessreg
Requires: usermode
Requires: cdialog
Requires: zenity
Requires: gksu
Requires: drakx-kbd-mouse-x11
Requires: xinitrc >= 2.4.14
Requires: openssh-clients
Requires: gdm-theme-pclinuxos
BuildRequires: %{_lib}x11-static-devel
BuildRequires: x11-server-xorg
BuildRequires: x11-server-xephyr
BuildRequires: gettext
BuildRequires: libglade2.0-devel
BuildRequires: librsvg-devel
BuildRequires: pam-devel
BuildRequires: usermode
BuildRequires: scrollkeeper
BuildRequires: gnome-doc-utils
BuildRequires: automake1.9 intltool
BuildRequires: consolekit-devel
BuildRequires: libwrap-devel
BuildRequires: zenity
BuildRequires: perl-XML-Parser

%description
Gdm (the GNOME Display Manager) is a highly configurable
reimplementation of xdm, the X Display Manager. Gdm allows you to log
into your system with the X Window System running and supports running
several different X sessions on your local machine at the same time.

%package Xnest
Summary: Xnest (ie embedded X) server for GDM
Group: %{group}
Requires: %{name} = %{version}
Requires: x11-server-xephyr
Conflicts: legacy-gdm-Xnest

%description Xnest
Gdm (the GNOME Display Manager) is a highly configurable
reimplementation of xdm, the X Display Manager. Gdm allows you to log
into your system with the X Window System running and supports running
several different X sessions on your local machine at the same time.

This package add support for Xnest server in gdm

%prep
%setup -q

%patch0 -p1 -b .defaultconf
%patch1 -p1 -b .xvt
%patch4 -p1 -b .pam
%patch5 -p1 -b .cleanup_xses
%patch6 -p1 -b .tmpdir
%patch7 -p1 -b .usermode
%patch8 -p1 -b .gdmlang
%patch10 -p1 -b .zhlocale
%patch12 -p1 -b .face
%patch14 -p1
%patch15 -p1 -b .rootpixmap
%patch16 -p1 -b .waitforrestart

%build
autoreconf -fi
export CFLAGS="-lXau -lm"
%configure2_5x --sysconfdir=%{_sysconfdir}/X11 \
  --disable-scrollkeeper --with-console-kit=yes --enable-secureremote=yes \
 --localstatedir=%{_var}/lib 
%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std PAM_PREFIX=%{_sysconfdir} 

# don't provide PreSession/PostSession, pam handle this
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/X11/PreSession/Default
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/X11/PostSession/Default

#broke at the moment
ln -s consolehelper $RPM_BUILD_ROOT%{_bindir}/gdmsetup
perl -pi -e "s^%{_sbindir}/^^" %buildroot%_datadir/applications/gdmsetup.desktop

mkdir -p $RPM_BUILD_ROOT%{_datadir}/hosts

mkdir -p  $RPM_BUILD_ROOT%{_liconsdir} $RPM_BUILD_ROOT%{_miconsdir}
cp %{SOURCE2} $RPM_BUILD_ROOT%{_liconsdir}/gdm.png
cp %{SOURCE3} $RPM_BUILD_ROOT%{_iconsdir}/gdm.png
cp %{SOURCE4} $RPM_BUILD_ROOT%{_miconsdir}/gdm.png

mkdir -p $RPM_BUILD_ROOT%{_datadir}/PolicyKit/policy
install -m644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/PolicyKit/policy

#config for ConsoleKit
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d/
install -m644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d/gdm-ConsoleKit.conf

mkdir -p $RPM_BUILD_ROOT%{_var}/log/gdm $RPM_BUILD_ROOT%{_sysconfdir}/X11/dm/Sessions

#remove unpackaged files
rm -rf   $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/modules/*.{la,a} \
  $RPM_BUILD_ROOT%{_sysconfdir}/X11/gdm/PostLogin/Default.sample \
  $RPM_BUILD_ROOT%{_datadir}/xsessions/gnome.desktop

install -m 0644 %SOURCE7 $RPM_BUILD_ROOT/%_datadir/gdm/applications/gdmsetup.desktop
install -m 0644 %SOURCE8 $RPM_BUILD_ROOT/%_datadir/gdm/defaults.conf
install -m 0644 %SOURCE9 $RPM_BUILD_ROOT/%_datadir/gdm/factory-defaults.conf

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%pre
%_pre_useradd gdm %{_var}/lib/gdm /bin/false
%_pre_groupadd xgrp gdm

%triggerpostun -- gdm < 2.8.0.0-2mdk
#replace changed paths in gdm.conf
sed -i -e "s^%_bindir/\(gdm[^ \t]\+\)^%_libexecdir/\1^g"  %{_sysconfdir}/X11/gdm/gdm.conf

%post
if [ -f /%{_sysconfdir}/X11/xdm/Xsession -a ! -x /%{_sysconfdir}/X11/xdm/Xsession ]; then
	chmod +x /%{_sysconfdir}/X11/xdm/Xsession
fi

if [ -x /usr/sbin/chksession ]; then /usr/sbin/chksession -g || true; fi

/sbin/ldconfig
%update_scrollkeeper
# Attempt to restart GDM softly by use of the fifo.  Wont work on older
# then 2.2.3.1 versions but should work nicely on later upgrades.
# FIXME: this is just way too complex
FIFOFILE=`grep '^ServAuthDir=' %{_sysconfdir}/X11/gdm/custom.conf | sed -e 's/^ServAuthDir=//'`
if test x$FIFOFILE = x ; then
        FIFOFILE=%{_var}/lib/gdm/.gdmfifo
else
        FIFOFILE="$FIFOFILE"/.gdmfifo
fi
PIDFILE=`grep '^PidFile=' %{_sysconfdir}/X11/gdm/custom.conf | sed -e 's/^PidFile=//'`
if test x$PIDFILE = x ; then
        PIDFILE=/var/run/gdm.pid
fi
if test -w $FIFOFILE ; then
        if test -f $PIDFILE ; then
                if kill -0 `cat $PIDFILE` 2> /dev/null ; then
                        (echo;echo SOFT_RESTART) >> $FIFOFILE
                fi
        fi
fi
# ignore error in the above
exit 0


# don't ship .la
find %{buildroot} -name '*.la' -exec rm -f {} \;


%posttrans
if [ -f /etc/X11/gdm/custom.conf.rpmsave ]; then
mv /etc/X11/gdm/custom.conf.rpmsave /etc/X11/gdm/custom.conf
fi


%preun
rm -f %{_datadir}/gdm/themes/mdk > /dev/null


%postun
%{make_session}
%_postun_userdel gdm
%_postun_groupdel xgrp gdm
/sbin/ldconfig
%clean_scrollkeeper

%files
%defattr(-, root, root)

%doc AUTHORS COPYING NEWS README gui/greeter/greeter.dtd
%_sysconfdir/dbus-1/system.d/*
%_bindir/gdmdynamic
%_bindir/gdmsetup
%{_bindir}/gdmphotosetup
%{_bindir}/gdmflexiserver
%{_libexecdir}/gdmchooser
%{_libexecdir}/gdmgreeter
%{_libexecdir}/gdmlogin
%{_libexecdir}/gdmaskpass
%{_libexecdir}/gdmopen
%{_libexecdir}/gdmtranslate
%{_libexecdir}/gdm-ssh-session
%{_sbindir}/*
%dir %{_sysconfdir}/X11/gdm
%{_sysconfdir}/X11/gdm/XKeepsCrashing
%config(noreplace) %{_sysconfdir}/pam.d/gdm
%config(noreplace) %{_sysconfdir}/pam.d/gdmsetup
%config(noreplace) %{_sysconfdir}/pam.d/gdm-autologin
%config(noreplace) %{_sysconfdir}/security/console.apps/gdmsetup
%config(noreplace) %{_sysconfdir}/X11/gdm/custom.conf
%config(noreplace) %{_sysconfdir}/X11/gdm/locale.alias
%config(noreplace) %{_sysconfdir}/X11/gdm/Xsession
%dir %{_sysconfdir}/X11/dm
%dir %{_sysconfdir}/X11/dm/Sessions
%config(noreplace) %{_sysconfdir}/X11/gdm/PreSession
%config(noreplace) %{_sysconfdir}/X11/gdm/PostSession
%config(noreplace) %{_sysconfdir}/X11/gdm/PostLogin
%config(noreplace) %{_sysconfdir}/X11/gdm/Init
%config(noreplace) %{_sysconfdir}/X11/gdm/modules
%{_libdir}/gtk-2.0/modules/*.so
%{_datadir}/pixmaps/*
%{_datadir}/gdm
%{_datadir}/PolicyKit/policy/*
%dir %{_datadir}/hosts
%attr(1770, gdm, gdm) %dir %{_var}/lib/gdm
%dir %{_var}/log/gdm
%_datadir/icons/hicolor/*/apps/gdm*
%{_liconsdir}/*.png
%{_iconsdir}/*.png
%{_miconsdir}/*.png
%{_mandir}/man1/*
#%dir %{_datadir}/xsessions
%exclude %{_datadir}/xsessions/ssh.desktop
%{_datadir}/locale/*
%{_datadir}/gnome/help/*
%{_datadir}/omf/*

%files Xnest
%defattr(-, root, root)
%{_bindir}/gdmthemetester
%{_bindir}/gdmXnestchooser
%{_bindir}/gdmXnest
#%{_bindir}/gdm-dmx-reconnect-proxy


%changelog
* Wed Jun 26 2013 Texstar <texstar at gmail.com> 2.20.11-4pclos2013
- replace gdm gnome 3 with gdm gnome 2 version 

* Thu Oct 14 2010 Texstar <texstar at gmail.com> 2.20.11-3pclos2010
- exclude xsession folder as it is not used in pclinuxos

* Sun Oct 10 2010 Texstar <texstar at gmail.com> 2.20.11-2pclos2010
- add posttran to restore custom.conf

* Sat Jul 18 2010 Texstar <texstar at gmail.com> 2.20.11-1pclos2010
- 2.20.11
- add patch 15 & 16

* Sat Jan 02 2010 Texstar <texstar at gmail.com> 2.20.10-3pclos2010
- rebuild

* Mon May 11 2009 Texstar <texstar@gmail.com> 2.20.10-2pclos2009
- fix gdm desktop file per Ken

* Mon May 11 2009 Texstar <texstar@gmail.com> 2.20.10-1pclos2009
- 2.20.10

* Fri Oct 24 2008 Neverstopdreaming <neverstopdreaming@gmail.com> 2.20.9-1pclos2007
- Rebuild

* Fri May 09 2008 Slick50 <linuxgator.org> 2.20.3-2pclos2007
- removed Tux_G2_Vert patch added Avio-GDM for defaut theme

* Fri Apr 25 2008 Slick50 <linuxgator.org> 2.20.3-1pclos2007
- 2.20.3

* Wed Dec 19 2007 Texstar <texstar@gmail.com> 2.20.2-3pclos2007
- require gdm themes
- patch to use Tux_G2_vert by default

* Sat Dec 01 2007 Texstar <texstar@gmail.com> 2.20.2-2pclos2007
- rebuild

* Sat Dec 01 2007 Texstar <texstar@gmail.com> 2.20.2-1pclos2007
- 2.20.2
